// Copyright © 2005, Esko Luontola <www.orfjackal.net>
// This software is released under the Apache License 2.0.
// The license text is at http://www.apache.org/licenses/LICENSE-2.0

package net.orfjackal.sorsastus;

/**
 * Counts the lines of code from source code files.
 *
 * @author Esko Luontola
 */
public class Sorsastus {

    public static final String APP_NAME = "Sorsastus";
    public static final String APP_VERSION = "0.6";
    public static final String APP_COMMAND = "java -jar Sorsastus.jar";
    public static final String APP_DESCRIPTION = "Counts the lines of code and other metrics from source code files.";
    public static final String COPYRIGHT = "Copyright (C) 2005 Esko Luontola, www.orfjackal.net";

    public static void main(String[] args) {
//        System.getProperties().list(System.out);
//        System.out.println("------------");
//        for (Map.Entry<Object, Object> entry : System.getProperties().entrySet()) {
//            System.out.println(entry.getKey() + "=" + entry.getValue());
//        }
//        if (true) return;

        AnalyzerBatch analyzer = new AnalyzerBatch();
        SorsastusLauncher launcher = new SorsastusLauncher(analyzer);
        launcher.parse(args);
    }
}
