// Tietorakenteiden harjoitusty (syksy 2004), Esko Luontola
// Tietoliikenneverkon reititysalgoritmien vertailu, "Sim Router"

/**
 * Ryhmitt toiseen reitittimeen menevn ja tulevan porttiparin.
 */
public class DuplexPort {
	
	public final RecievePort input;
	
	public final SendPort output;
	
	private final int target;
	
	/**
	 * Luo kaksisuuntaisen portin. Portit input ja output ovat yhteyden tss
	 * pss, ja target on sen reitittimen osoite, joka on toisessa pss.
	 */
	public DuplexPort(RecievePort input, SendPort output, int target) {
		this.input = input;
		this.output = output;
		this.target = target;
	}
	
	/**
	 * Reititin johon nm portit ovat yhteydess.
	 */
	public int getTarget() {
		return target;
	}
	
	/**
	 * Palauttaa lhetysportin merkkiesityksen.
	 * 
	 * @see SendPort#toString()
	 */
	public String toString() {
		return output.toString();
	}
}
