// Tietorakenteiden harjoitusty (syksy 2004), Esko Luontola
// Tietoliikenneverkon reititysalgoritmien vertailu, "Sim Router"

/**
 * Pelkistetty vastine Javan Vector-luokalle.
 */
public class Vector {
	
	private static final int MIN_SIZE = 8;
	
	private Object[] array;
	private int size;
	
	/**
	 * Luo tyhjn vektorin.
	 */
	public Vector() {
		array = new Object[MIN_SIZE];
		size = 0;
	}
	
	/**
	 * Palauttaa alkioiden lukumrn.
	 */
	public int size() {
		return size;
	}
	
	/**
	 * Lis alkion tmn vektorin loppuun.
	 */
	public void add(Object obj) {
		if (size == array.length) {
			Object[] newarray = new Object[array.length * 2];
			for (int i = 0; i < array.length; i++) {
				newarray[i] = array[i];
			}
			array = newarray;
		}
		array[size] = obj;
		size++;
	}
	
	/**
	 * Poistaa annetussa indeksiss olevan olion. Siirt loppuosassa olevia
	 * alkioita alkuun pin.
	 */
	public Object remove(int index) {
		if (index >= size) {
			throw new ArrayIndexOutOfBoundsException();
		}
		Object result = array[index];
		
		while (index + 1 < size) {
			array[index] = array[index + 1];
			index++;
		}
		array[index] = null;
		size--;
		
		if (array.length > MIN_SIZE && size * 4 < array.length) {
			Object[] newarray = new Object[array.length / 2];
			for (int i = 0; i < size; i++) {
				newarray[i] = array[i];
			}
			array = newarray;
		}
		
		return result;
	}
	
	/**
	 * Palauttaa annetussa indeksiss olevan alkion.
	 */
	public Object get(int index) {
		if (index >= size) {
			throw new ArrayIndexOutOfBoundsException();
		}
		return array[index];
	}
	
	/**
	 * Korvaa annetussa indeksiss olevan alkion toisella.
	 */
	public void set(int index, Object obj) {
		if (index >= size) {
			throw new ArrayIndexOutOfBoundsException();
		}
		array[index] = obj;
	}
	
	public static void main(String[] args){
		Vector v = new Vector();
		
		for (int i = 0; i < 100; i++) {
			v.add(new Object());
			System.out.println(v.size() +"/"+ v.array.length);
		}
		for (int i = 0; i < 100; i++) {
			v.remove(v.size()-1);
			System.out.println(v.size() +"/"+ v.array.length);
		}
	}
}
